
open Format

type t = int * int

let dummy = (0,0)

let make f (s, e) =
  let cin = open_in f in
  let return l ls = close_in cin; l, s - ls, e - ls in
  let rec lookup l ls n =
    assert (ls <= n);
    if n = s then
      return l ls
    else
      try
        let c = input_char cin in
        if c = '\n' then lookup (succ l) (succ n) (succ n)
        else lookup l ls (succ n)
      with End_of_file -> assert false
  in
  lookup 1 0 0

let report f l =
  if l != dummy then
    let l,fc,lc = make f l in
    eprintf "File \"%s\", line %d, characters %d-%d:\n" f l (fc+1) (lc+1)


