
/* arbres binaires de recherche */

class ABR {
    private int valeur;
    private ABR gauche;
    private ABR droite;

    ABR(int v) { valeur = v; gauche = null; droite = null; }

    ABR(ABR g, int v, ABR d) { valeur = v; gauche = g; droite = d; }

    void insere(int x) {
	if (x == valeur) return;
	if (x < valeur) {
	    if (gauche == null) 
		gauche = new ABR(x);
	    else
		gauche.insere(x);
	} else
	    if (droite == null)
		droite = new ABR(x);
	    else
		droite.insere(x);
    }
    
    boolean contient(int x) {
	if (x == valeur) return true;
	if (x < valeur && gauche != null) return gauche.contient(x);
	if (droite != null) return droite.contient(x);
	return false;
    }

    String toStr() {
	String s = "";
	if (gauche != null) s = gauche.toStr();
	s = s + "(" + valeur + ")";
	if (droite != null) s = s + droite.toStr();
	return s;
    }

    static String toStr2(ABR a) {
	if (a == null) return "";
	return toStr2(a.gauche) + "(" + a.valeur + ")" + toStr2(a.droite);
    }

}

class Main {

    static void main() {

	ABR dico = new ABR(1);
	dico.insere(17);
	dico.insere(5);
	dico.insere(8);

	if (dico.contient(5) &&
	    ! dico.contient(0) &&
	    dico.contient(17) &&
	    ! dico.contient(3) &&
	    dico.toStr().equals("(1)(5)(8)(17)") &&
	    "(1)(5)(8)(17)".equals(ABR.toStr2(dico))) 
	    System.out.println("ok");
    }

}
    
