
/*** listes circulaires doublement chanes ***/

class ListeC
{
    
    int valeur;
    ListeC suivant, precedent;
    
    ListeC() {} 

    /* liste rduite  un lment */
    static ListeC singleton(int v) 
    {
	ListeC l = new ListeC();
	l.valeur = v;
	l.suivant = l.precedent = l;
	return l;
    }

    /* insertion aprs un lment donne */
    static void insererApres(ListeC l, int v)
    {
	ListeC e = new ListeC();
	e.valeur = v;
	e.suivant = l.suivant;
	l.suivant = e;
	e.suivant.precedent = e;
	e.precedent = l;
    }

    /* suppression d'un lment donn */
    static void supprimer(ListeC l)
    {
	l.precedent.suivant = l.suivant;
	l.suivant.precedent = l.precedent;
    }

    /* affichage */
    static void afficher(ListeC l) 
    {
	ListeC c = l;
	System.out.println(c.valeur + " ");
	c = c.suivant;
	while (c != l) 
        {
	    System.out.println(c.valeur + " ");
	    c = c.suivant;
        }
	System.out.println("");
    }

}

/*** Partie 3 : problme de Josephus ***/

class Josephus 
{

    /* construction de la liste circulaire 1,2,...,n;
       l'lment retourn est celui contenant 1 */
    static ListeC cercle(int n)
    {
	ListeC l = ListeC.singleton(1);
	for (int i = n; i >= 2; i--)
	{
	    ListeC.insererApres(l, i);
	}
	return l;
    }

    /* jeu de Josephus */
    static int josephus(int n, int p)
    {
	/* c est le joueur courant, 1 au dpart */
	ListeC c = cercle(n);

	/* tant qu'il reste plus d'un joueur */
	while (c != c.suivant)
	{
	    /* on limine un joueur */
	    for (int i = 1; i < p; i++)	c = c.suivant;
	    ListeC.supprimer(c);
	    // System.out.println(c.valeur + " est limin");
	    c = c.suivant;
	}
	// System.out.println("le gagnant est " + c.valeur);
	return c.valeur;
    }   

}

/*** Tests ***/

class Main
{

    static void main() 
    {
//  	ListeC l = ListeC.singleton(1);
//  	ListeC.afficher(l);
//  	ListeC.insererApres(l, 3);
//  	ListeC.afficher(l);
//  	ListeC.insererApres(l, 2);
//  	ListeC.afficher(l);
//  	ListeC.supprimer(l.suivant);
//  	ListeC.afficher(l);

//	ListeC c = Josephus.cercle(7);
//	ListeC.afficher(c);

	if (Josephus.josephus(7, 5) == 6 &&
	    Josephus.josephus(5, 5) == 2 &&
	    Josephus.josephus(5, 17) == 4 &&
	    Josephus.josephus(13, 2) == 11) 
	    System.out.println("ok");
    }

}
