/* Un petit peu d'arithmtique...

   n.b.: l'implmentation n'est pas splendide due aux limitations du 
   sous-ensemble de java considr et  la volont d'avoir de la redfinition
   et de la surcharge... 
   Histoire d'avoir un test du compilateur intressant ;). */

class Complex {
    private double re = 0, im = 0;

    Complex() { }

    Complex(double re, double im) { set(re, im); }

    double re() { return re; }
    double im() { return im; }

    void set(double re, double im) { this.re = re;; this.im = im; }

    boolean est_reel() { return diff_eps(im, 0); }
    boolean est_imaginaire() { return diff_eps(re, 0); }

    Complex plus(Complex c) { return new Complex(re + c.re, im + c.im); }

    Complex moins(Complex c) { return new Complex(re - c.re, im - c.im); }

    Complex mult(Complex c) { 
	return new Complex(re * c.re - im * c.im, re * c.im + im * c.re);
    }

    Complex div(Complex c) {
	double denom = c.re * c.re + c.im * c.im;
	Complex num = mult(new Complex(c.re, - c.im));
	return new Complex(num.re / denom, num.im / denom);
    }

    static Complex plus(Complex c1, Complex c2) { return c1.plus(c2); }
    static Complex moins(Complex c1, Complex c2) { return c1.moins(c2); }
    static Complex mult(Complex c1, Complex c2) { return c1.mult(c2); }
    static Complex div(Complex c1, Complex c2) { return c1.div(c2); }

    private static boolean diff_eps(double a, double b) {
	double eps = 1e-6;
	double diff = a - b;
	return diff < eps && diff > - eps;
    }

    boolean equals(Complex c) { 
	return diff_eps(re, c.re) && diff_eps(im, c.im); 
    }

    String to_string() {
	String s = "";
	boolean non_reel = ! est_reel();

	if (! est_imaginaire()) {
	    s = s + re;
	    if (im > 0)
		s = s + "+";
	    else
		if (im == 0)
		    return s;
	}
	if (non_reel) {
	    if (im != 1)
		s = s + im;
	    return s + "i";
	}
	return "0";
    }
}

class Real extends Complex {
    Real() { set(0); }
    Real(double x) { set(x); }

    void set(double x) { set(x, 0); }

    Real plus(Real x) { return new Real(re() + x.re()); }
    Real moins(Real x) { return new Real(re() - x.re()); }
    Real mult(Real x) { return new Real(re() * x.re()); }
    Real div(Real x) { return new Real(re() / x.re()); }

    static Real plus(Real x, Real y) { return x.plus(y); }
    static Real moins(Real x, Real y) { return x.moins(y); }
    static Real mult(Real x, Real y) { return x.mult(y); }
    static Real div(Real x, Real y) { return x.div(y); }
}

// tests
class Main {
    static void main() {
	boolean b = true;

	// tests sur les complexes
	Complex c1 = new Complex(), c2 = new Complex(3.5, 2.8);
	b = b && c1.to_string().equals("0");
	b = b && c2.to_string().equals("3.5+2.8i");
	b = b && c1.plus(c2).to_string().equals(c2.to_string());
	b = b && c1.moins(c2).to_string().equals("-3.5-2.8i");
	b = b && c2.mult(c2).equals(new Complex(4.41, 19.6));
	b = b && c2.div(c2).equals(new Complex(1, 0));
	b = b && c1.plus(c2).equals(Complex.plus(c1, c2));
	b = b && c1.moins(c2).equals(Complex.moins(c1, c2));
	b = b && c1.mult(c2).equals(Complex.mult(c1, c2));
	b = b && c1.div(c2).equals(Complex.div(c1, c2));

	// tests sur les rels
	Real x = new Real(), y = new Real(- 4);
	b = b && x.to_string().equals("0");
	b = b && y.equals(new Real(- 4));
	b = b && x.plus(y).to_string().equals(y.to_string());
	b = b && x.moins(y).equals(new Real(4));
	b = b && y.mult(y).equals(new Real(16));
	b = b && y.div(y).equals(new Real(1));
	b = b && x.plus(y).equals(Real.plus(x, y));
	b = b && x.moins(y).equals(Real.moins(x, y));
	b = b && x.mult(y).equals(Real.mult(x, y));
	b = b && x.div(y).equals(Real.div(x, y));

	// tests vrifiant la bonne mthode appele
	b = b && ! (x.plus(c1) instanceof Real);
	b = b && ! (c1.plus(x) instanceof Real);
	b = b &&   x.plus(y) instanceof Real;
	b = b && ! (Real.plus(x, c1) instanceof Real);
	b = b && ! (Real.plus(c1, x) instanceof Real);
	b = b &&   Real.plus(x, y) instanceof Real;
	b = b && ! (Complex.plus(x, y) instanceof Real);
	b = b && ! (x.plus((Complex)y) instanceof Real);
	c2 = new Real(c2.re());
	b = b && ! (x.plus(c2) instanceof Real);
	b = b &&   x.plus((Real)c2) instanceof Real;
	b = b && ! (Real.plus(x, c2) instanceof Real);
	b = b && ! (c2.plus(x, c2) instanceof Real);
	b = b && ! (c2.plus(x, (Real)c2) instanceof Real);
	b = b &&   ((Real)c2).plus(x, (Real)c2) instanceof Real;
	b = b &&   Real.plus(x, (Real)c2) instanceof Real;
	b = b && ! (Complex.plus(x, (Real)c2) instanceof Real);

	if (b)
	    System.out.println("ok");
    }
}
